/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2006, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item
XPCOM

*/

const nuc_contract_id = "@mozilla.org/netusagesvc;1";
const nuc_class_id = "{823EB6E4-7DC8-474D-B15F-DB10367662BC}";



nsNetUsageSvc.prototype = {
	


	init: function() {
		var scriptinc = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService().QueryInterface(Components.interfaces.mozIJSSubScriptLoader);
		scriptinc.loadSubScript("chrome://netusageitem/content/usagelib.js");

		//this.items[0] = Components.classes['@mozilla.org/netusageitem;1'].createInstance(Components.interfaces.nsINetUsageItem);
		//this.items[0].init(0);
		
		// create a dir for usage reports
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		file.append("netusage");
		if (!file.exists() || !file.isDirectory()) {
			//file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
		}
		
		// try to port old prefs over
		this.update_prefs();
		
		// open welcome page for first run
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var pfr = 1;
		var pref;
		try {
		pref = prefSvc.getBranch("extensions.netusage.");
		pfr = pref.getIntPref("firstrun");
		} catch(e) { }
		try {
		pref = prefSvc.getBranch("extensions.netusage.");
		pref.setIntPref("firstrun", 0);
		} catch(e) { }
		
		if (pfr) {
			var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
			ww.openWindow(ww.activeWindow, "chrome://netusageitem/content/welcome.xhtml", null, "titlebar,dialog=yes,width=505,height=500,alwaysRaised=yes", null);
		}
	},
	
	uninit: function() {
		for (var id in this.items) {
			this.items[id].QueryInterface(Components.interfaces.nsINetUsageItem);
			this.items[id].uninit();
			this.items[id] = null;
		}
	},
	
	update_prefs: function() {
		var pref, prefISP, checkinterval, override_limit, override_limitpo, override_startday;
		
		var prefSvc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		try {
		pref = prefSvc.getBranch("extensions.netusage.");
		} catch(e) { }
		try {
		prefISP = pref.getCharPref("userisp");
		pref.clearUserPref("userisp");
		} catch(e) { }
		try {
		checkinterval = pref.getIntPref("checkinterval");
		pref.clearUserPref("checkinterval");
		} catch(e) { }
		try {
		override_limit = pref.getIntPref("override_limit");
		pref.clearUserPref("override_limit");
		} catch(e) { }
		try {
		override_limitpo = pref.getIntPref("override_limitpo");
		pref.clearUserPref("override_limitpo");
		} catch(e) { }
		try {
		override_startday = pref.getIntPref("override_startday");
		pref.clearUserPref("override_startday");
		} catch(e) { }
		nuSavePass('net:usage:bar', null, null);
		/*
		if (prefISP && prefISP != '' && prefISP != 'na') {
			pref.setCharPref("0.userisp", prefISP);
		}
		if (checkinterval && checkinterval != '' && checkinterval > 0) {
			pref.setCharPref("0.checkinterval", checkinterval);
		}
		if (override_limit && override_limit > 0) {
			pref.setCharPref("0.checkinterval", prefcheckinterval);
		}
		if (override_limitpo && override_limitpo > 0) {
			pref.setCharPref("0.checkinterval", prefcheckinterval);
		}
		*/
	},
	
	//
	// nsINetUsageSvc
	//
	
	getItem: function(id) {
		if (!this.items[id]) {
			this.items[id] = Components.classes['@mozilla.org/netusageitem;1'].createInstance(Components.interfaces.nsINetUsageItem);
			this.items[id].init(id);
		}
		
		return this.items[id];
	},

	//
	// nsIObserver
	//

	observe: function (subject, topic, data) {
		switch (topic) {
			case 'xpcom-startup':
				// register for profile-after-change
				var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
				observerSvc.addObserver(this, 'profile-after-change', false);
				observerSvc.addObserver(this, 'profile-change-teardown', false);
				break;

			case 'profile-after-change':
				// fun starts here
				this.init();
				break;
				
			case 'profile-change-teardown':
				// TODO uninit
				ndump(topic);
				this.uninit();
				break;
		}
	},



	//
	// nsISupports
	//


	QueryInterface: function (iid) {
		if (!iid.equals(Components.interfaces.nsINetUsageSvc) &&
			!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsIObserver)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
}



function nsNetUsageSvc() {
	this.items = {};

}




// MODULE
var module = {
	firstTime: true,

	cid: Components.ID(nuc_class_id),

	contractId: nuc_contract_id,

	registerSelf: function (compMgr, fileSpec, location, type) {
		if (this.firstTime) {
			// defer first time registering, I have no idea why though :/
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(this.cid, "Net Usage Service", this.contractId, fileSpec, location, type);

		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService().QueryInterface(Components.interfaces.nsICategoryManager);
		catman.addCategoryEntry("xpcom-startup", "Net Usage", nuc_contract_id, true, true);
	},

	unregisterSelf: function(compMgr, fileSpec, location) {
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.unregisterFactoryLocation(this.cid, fileSpec);
	},

	canUnload: function(compMgr) {
		return true;
	},

	// getClassObject: returns component's factory object
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.cid)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		if (!iid.equals(Components.interfaces.nsIFactory)) {
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.factory;
	},

	// factory object
	factory: {
		createInstance: function (outer, iid) {
			if (outer != null)
				throw Components.results.NS_ERROR_NO_AGGREGATION;
			return (new nsNetUsageSvc()).QueryInterface(iid);
		}
	}
};

function NSGetModule(compMgr, fileSpec) {
	return module;
}