/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2006, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item

*/

var passentryid = 'net:usage:bar:';
const xul_pref_prefix = 'extensions.netusage.0';
var pref_prefix = 'extensions.netusage.';
var oldpass;
var settingsChanged = false;
var isp;
var oldispid;
var extversion;
var itemid;

function startup() {
	try {
	if (window.arguments != undefined)
		itemid = parseInt(window.arguments[0]);
	else
		itemid = 0;
	pref_prefix += itemid;
	passentryid += itemid;

	moveTo(screen.width/2-450/2,screen.height/2-500/2);
	
	oldpass = nuLoadPass(passentryid);
	var uuname = document.getElementById("uuname");
	var upass = document.getElementById("upass");
	if (oldpass != false) {
		uuname.value = oldpass[1];
		upass.value = oldpass[2];
	}

	refreshCountryList();

	// load the current pref values, refreshISPPrefs depends on selected isp
	loadSettings();
	
	// refresh ISP setting prefs
	refreshISPPrefs(true);
	
	// select correct country of ISP
	var ispid = document.getElementById('selisp').value;
	var ct;
	if (ispid.indexOf('.') != -1)
		ct = ispid.substring(0, ispid.indexOf('.'));
	else
		ct = 'au';
	document.getElementById("selcountry").value = ct;
	refreshISPList(ct);
	
	// load the current pref values again, for the new isp fields
	loadSettings();
	
	// Mozilla specific
	if ('hPrefWindow' in parent) {
		parent.hPrefWindow.registerOKCallbackFunc(onOK);
	}
	// Find out our version
	document.getElementById('nuiversion').value = "v" + nuGetVersion() + " item " + itemid;
	} catch(e) { alert(e); }
}

function refreshCountryList() {
	var cts = {};
	nuLoadPrefList("extensions.netusage.isps.", cts);
	var sel = document.getElementById('selcts');
	var elt = document.getElementById('ct_more');
	for (var myct in cts) {
		var elx = elt.cloneNode(false);
		elx.value = myct;
		elx.label = cts[myct];
		sel.appendChild(elx);
	}
}

function refreshISPList(ct) {
	removeAllChildren(document.getElementById('selisps'), true);
	
	if (ct == null) {
		//
		document.getElementById("selisp").value = "na";
		refreshISPPrefs(false);
		
		ct = document.getElementById("selcountry").value;
		if (ct == 'more') {
			// go to more countries
			alert("To get more countries, please visit the home page http://netusage.iau5.com/");
			return;
		}
	}
	var isps = nuGetISPList(ct);
		
	// fill ISP selection box
	var ispa;
	var elsel = document.getElementById('selisp');
	var sel = document.getElementById('selisps');
	var elt = document.getElementById('ispsna');
	for (var ispk in isps) {
		var elx = elt.cloneNode(false);
		elx.value = ispk;
		elx.setAttribute("custompref", "true");
		elx.label = isps[ispk].name;
		sel.appendChild(elx);
	}
}

function refreshISPPrefs(initialrun) {
	removeAllChildren(document.getElementById('ispprefgrid'), false);
	removeAllChildren(document.getElementById('generalgrid'), true);
	
	// reset username and password fields
	document.getElementById('rowuuname').setAttribute('style', '');
	document.getElementById('lbluuname').value = 'Username';

	document.getElementById('rowupass').setAttribute('style', '');
	document.getElementById('lblupass').value = 'Password';
	
	var lbldescisp = document.getElementById('lbldescisp');
	removeAllChildren(lbldescisp, false);
	
	var selisp = document.getElementById('selisp');
	if (selisp.value == 'na') return;
	
	isp = nuGetISPInterface(selisp.value);

	if (isp == null) {
		alert('Unknown ISP '+selisp.value+'. Please reselect.');
		if (!oldispid) oldispid = 'na';
		return;
	}
	if (!oldispid) oldispid = selisp.value;

	if (isp.description)
		lbldescisp.appendChild(document.createTextNode(isp.description));

	
	// populate prefs
	if (!isp.prefs)
		isp.prefs = { };
	for (var k in isp.prefs) {
		if (k == 'USERNAME') {
			if (isp.prefs[k] == null) {
				document.getElementById('rowuuname').setAttribute('style', 'display: none');
			} else {
				document.getElementById('rowuuname').setAttribute('style', '');
				document.getElementById('lbluuname').value = isp.prefs[k];
			}
		} else if (k == 'PASSWORD') {
			if (isp.prefs[k] == null) {
				document.getElementById('rowupass').setAttribute('style', 'display: none');
			} else {
				document.getElementById('rowupass').setAttribute('style', '');
				document.getElementById('lblupass').value = isp.prefs[k];
			}
		} else
			newISPPref(isp.prefs[k][0], k, isp.prefs[k][1], isp.prefs[k][2]);
	}
	
	// resize
	if (!initialrun) {
		var btnok = document.getElementById('btnok').boxObject;
		window.innerHeight = btnok.y + btnok.height + 5;
	}
}

function removeAllChildren(el, onlycustompref) {
	for(var i = el.childNodes.length-1; i != -1; i--) {
		if (onlycustompref && el.childNodes[i].getAttribute('custompref') != 'true')
			continue;
		el.removeChild(el.childNodes[i]);
	}
}

function newISPPref(title, prefkey, prefflags, options) {
	var prefgrid = document.getElementById('ispprefgrid');
	var prefgeneralgrid = document.getElementById('generalgrid');
	var xulns = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
	
	var row = document.createElement('row', xulns);
	
	var c0 = document.createElement('description', xulns);
	c0.setAttribute('value', title);
	//c0.setAttribute('class', cssclass);
	row.appendChild(c0);
	var c1, cpop, cc, i;
	if (options) {
		// create select option
		c1 = document.createElement('menulist', xulns);
		cpop = document.createElement('menupopup', xulns);
		for (i in options) { // TODO support general arrays
			cc = document.createElement('menuitem', xulns);
			cc.setAttribute('label', i);
			cc.setAttribute('value', options[i]);
			cpop.appendChild(cc);
		}
		if (prefflags & PREF_FLAG_LIST_EDITABLE)
			c1.setAttribute('editable', 'true');
		c1.appendChild(cpop);
	} else
		// create text box
		c1 = document.createElement('textbox', xulns);
		
	//c1.setAttribute('class', cssclass);
	
	if (prefflags & PREF_TYPE_INT) c1.setAttribute('preftype', 'int');
	else if (prefflags & PREF_TYPE_STRING) c1.setAttribute('preftype', 'string');
	else if (prefflags & PREF_TYPE_BOOL) c1.setAttribute('preftype', 'bool');
	
	c1.setAttribute('prefstring', pref_prefix+".vars."+prefkey);
	
	if (prefflags & PREF_FLAG_LIST_EDITABLE)
		c1.setAttribute('prefattribute', "label");
	else
		c1.setAttribute('prefattribute', "value");
	row.appendChild(c1);
	row.setAttribute('custompref', 'true');
	
	if (prefflags & PREF_FLAG_GENERAL)
		prefgeneralgrid.appendChild(row);
	else
		prefgrid.appendChild(row);
}

function onOK() {
	var upass = document.getElementById("upass");
	var uuname = document.getElementById("uuname");
	if (!oldpass || oldpass[1] != uuname.value || oldpass[2] != upass.value) {
		nuSavePass(passentryid, uuname.value, upass.value);
		settingsChanged = true;
	}
	if (uuname.value == '' || upass.value == '') {
		// set usage metre to disable?
	}

	saveSettings();

	if (settingsChanged) {
		/*try {
		// make a delay'd reload preference, allow time for mozilla 1.4's internal pref's saving
		var prefrltimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		// TODO: get rid of this crazy hack
		prefrltimer.init({ cmpn: Components,
			observe: function (subject, topic, data) {
				// JavaScript is an odd language!!
				//var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Component.interfaces.nsIObserverService);
				observerSvc.notifyObservers(this, 'netusage-update', 'pref');
			} }, 1000, prefrltimer.TYPE_ONE_SHOT);
		} catch (e) { alert(e) };
		var observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
		*/
	}
	return true;
}

function clearAllSettings() {
	var prefSvc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var pref = prefSvc.getBranch(pref_prefix);
	var childs = pref.getChildList("", { });
	for (var i = 0; i < childs.length; ++i) {
		try {
		pref.clearUserPref(childs[i]);
		} catch (e) {}
	}
	
	nuSavePass(passentryid, null, null);

	alert("All passwords and settings have been cleared.");	

	window.close();
}

function loadSettings() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var el, prefstring, preftype, prefattribute, value, k;
	var prefEls = document.getElementsByAttribute("prefstring", "*")
	
	for (var k=0; k<prefEls.length; k++) {
		el = prefEls[k];
		prefstring = el.getAttribute('prefstring');
		
		// replace the prefname prefix with one of the correct itemid
		if (prefstring.indexOf(xul_pref_prefix) == 0) {
			prefstring = pref_prefix+prefstring.substring(xul_pref_prefix.length, prefstring.length);
			el.setAttribute('prefstring', prefstring);
		}
		preftype = el.getAttribute('preftype');
		prefattribute = el.getAttribute('prefattribute') ? el.getAttribute('prefattribute') : 'value';

		try {
		switch(preftype) {
			case 'bool':
				value = pref.getBoolPref(prefstring);
				el.checked = value;
				break;

			case 'int':
				value = pref.getIntPref(prefstring);
				if (el.getAttribute('prefblankvalue') != undefined && value == parseInt(el.getAttribute('prefblankvalue'), 10))
					el.value = '';
				else
					el.value = value;
				break;

			case 'string':
			default:
				value = pref.getCharPref(prefstring);
				el.value = value;
				break;
		}
		//el.setAttribute(prefattribute, value);
		} catch(e) {}
	}
}

function saveSettings() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var el, prefstring, preftype, prefattribute, value, k;
	var prefEls = document.getElementsByAttribute("prefstring", "*")
	
	if (oldispid != 'na') { // TODO replace 'na' with ''
		// remove old isp specific custom vars
		var oldisp = nuGetISPInterface(oldispid);
		for (var pk in oldisp.prefs) {
			if (pk != 'USERNAME' || pk != 'PASSWORD') try {
				pref.clearUserPref(pref_prefix+".vars."+pk);
			} catch (e) {}
		}
	}
	
	for (var k=0; k<prefEls.length; k++) {
		el = prefEls[k];
		prefstring = el.getAttribute('prefstring');
		preftype = el.getAttribute('preftype');
		prefattribute = el.getAttribute('prefattribute') ? el.getAttribute('prefattribute') : 'value';
		value = (prefattribute == 'value') ? (el.value) : el.getAttribute(prefattribute); // stupid mozilla dom makes getAttribute('value') != el.value
		//alert((el.value)+' : '+el.getAttribute(prefattribute));

		switch(preftype) {
			case 'bool':
				pref.setBoolPref(prefstring, (value == 'true'));
				break;

			case 'int':
				if (value == '') {
					try {
					pref.clearUserPref(prefstring);
					} catch (e) {}
				} else
					pref.setIntPref(prefstring, parseInt(value));
				break;

			case 'string':
			default:
				pref.setCharPref(prefstring, value);
				break;
		}
	}
}